<?php
require_once('workflows.php');

$encode_query = urlEncode($query);

$all_config = array(
        'baidu' => array(
                'data' => "http://suggestion.baidu.com/su?ie=utf-8&p=3&cb=window.bdsug.sug&from=superpage&wd=%s",
                'url' => "http://www.baidu.com/s?ie=utf-8&wd=%s",
                'refer' => "http://www.baidu.com",

                'getTitle' => function($title) {
                        return $title;
                    },

                'getDesciption' => function($title) {
                        return '';
                    },
            ),
        'so' => array(
                'data' => "http://sug.so.360.cn/suggest/word?callback=suggest_so&encodein=utf-8&encodeout=utf-8&word=%s",
                'url' => "http://www.haosou.com/s?ie=utf-8&q=%s",
                'refer' => "http://www.haosou.com",

                'getTitle' => function($title) {
                        return $title;
                    },

                'getDesciption' => function($title) {
                        return '';
                    },
            ),
        'dianping' => array(
                'data' => "http://www.dianping.com/ajax/json/shopremote/search?do=hs&c=2&q=%s",
                'url' => "http://www.dianping.com/search/keyword/2/0_%s",
                'refer' => "http://www.dianping.com",

                'getTitle' => function($title) {
                        $arr = explode('|', $title);
                        return $arr[0];
                    },

                'getDesciption' => function($title) {
                        $arr = explode('|', $title);
                        return $arr[2];
                    },
            ),
    );

$config = $all_config[$type];
$icon = $type. ".png";
$url = sprintf($config['data'], $encode_query);

$ch = curl_init(); 
curl_setopt($ch, CURLOPT_URL, $url); 
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); 
curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Macintosh; Intel Mac OS X 10_8_4) AppleWebKit/537.31 (KHTML, like Gecko) Chrome/26.0.1410.65 Safari/537.31"); 
curl_setopt($ch, CURLOPT_REFERER, $config['refer']);
$res = curl_exec($ch); 
curl_close($ch);

preg_match("/\[\"(.*)\"\]/i", $res, $matches);
if(empty($matches)) {
    $list = array();
} else {
    $list = explode('","', $matches[1]);
}

array_unshift($list, $query);
$list = array_slice($list, 0, 9);

$wf = new Workflows();

foreach ($list as $item) {
    $title_func = $config['getTitle'];
    $title = $title_func($item);

    $desc_func = $config['getDesciption'];
    $desc = $desc_func($item);

    $url = sprintf($config['url'], urlEncode($title));
    $wf->result($title, $url, $title, $desc, $icon);
}

echo $wf->toxml();